minetest.register_on_mapgen_init(function(mgparams)
	minetest.set_mapgen_params({mgname="singlenode"})
end)

local zmodname = minetest.get_current_modname()
local zoctaves = 7
local zpersistance = 0.6

--content ids
local c_clay = minetest.get_content_id("default:clay")

--builder
minetest.register_on_generated(function(minp, maxp, seed)
 print ("generating",minetest.pos_to_string(minp),minetest.pos_to_string(maxp))
 local vm, emin, emax = minetest.get_mapgen_object("voxelmanip")
 local data = vm:get_data()
 local area = VoxelArea:new{MinEdge=emin, MaxEdge=emax} 
 local noise = minetest.get_perlin(0, zoctaves, zpersistance, 128)
 for x=minp.x, maxp.x, 1 do
  for z=minp.z, maxp.z, 1 do
   local n = noise:get2d({x=x,y=z})
   local q = math.abs(math.floor(n*64)) 
   local c=q-32
   if not c then c=64 end   
   for y=minp.y, maxp.y, 1 do
    if y<c then
     data[area:index(x, y, z)] = c_clay
    end --if y
   end --for y
  end --for z
 end --for x
 vm:set_data(data)
 vm:set_lighting({day=5,night=10})
 vm:calc_lighting()
 vm:update_liquids()
 vm:write_to_map()
end) --function

minetest.register_on_newplayer(function(player)
  local noise = minetest.get_perlin(0, zoctaves, zpersistance, 128)
  local rpos = player:getpos()
  local n = noise:get2d({x=x,y=z})
  local q = math.abs(math.floor(n*64)) 
  local c=q-32
  if not c then c=64 end   
  rpos.y=c+2
  print("spawning at:"..minetest.pos_to_string(rpos))
  player:setpos(rpos)
end) --function

